/*
* Copyright (c) 京北方信息技术股份有限公司 Corporation 2022 . All rights reserved.
*
*/
package net.northking.cctp.dw.api.atu.service;

import net.northking.cctp.common.db.excel.ExcelService;
import net.northking.cctp.common.db.Pagination;
import net.northking.cctp.common.http.QueryByPage;
import net.northking.cctp.dw.db.entity.DwAtuCaseDesign;
import net.northking.cctp.dw.dto.atu.*;

import java.util.List;

/**
 * 自动化用例设计同步表Restful逻辑接口
 * @author maven-cctp-plugin
 * @since 1.0
 */
public interface DwAtuCaseDesignApiService extends ExcelService
{
  /**
   * 查询自动化用例设计同步表列表
   *
   * @param queryByPage  查询条件
   * @return 查询结果列表
   */
  Pagination<DwAtuCaseDesignDetailDto> pagingQuery(QueryByPage<DwAtuCaseDesignQueryDto> queryByPage);

  /**
   * 新增自动化用例设计同步表
   *
   * @param dto         接口数据传输对象
   * @return 主键
   */
  String add(DwAtuCaseDesign dto);

  /**
   * 更新自动化用例设计同步表
   *
   * @param dto         接口数据传输对象
   * @return 修改的记录数量
   */
  Integer updateByPK(DwAtuCaseDesignUpdateDto dto) throws IllegalAccessException;

  /**
   * 获取自动化用例设计同步表
   * @param uuid 主键
   * @return 接口数据传输对象
   */
  DwAtuCaseDesignDetailDto findByPK(String uuid);

  /**
   * 删除自动化用例设计同步表
   * @param uuid  主键
   * @return 删除的记录数量
   */
  Integer deleteByPK(String uuid);

    /**
     * 批量新增
     *
     * @param batch 集合
     * @return 成功的数量
     */
    List<String> addBatch(List<DwAtuCaseDesign> batch);

    /**
     * 批量更新
     *
     * @param batch 集合
     * @return 成功的数量
     */
    Integer updateBatch(List<DwAtuCaseDesignUpdateDto> batch) throws IllegalAccessException;

    /**
     * 批量删除
     *
     * @param batch 集合
     * @return 成功的数量
     */
    Integer deleteBatch(List<Object> batch);

  DwAtuDetailTmpDto count(DwAtuCaseDesignQueryDto query);
}
